/**
 * Copyright (c) 2009 Jeremy Stribling, Yair Sovran, Irene Zhang, 
 *                    Xavid Pretzer, Jinyang Li, Frans Kaashoek, Robert Morris,
 *     		      Massachusetts Institute of Technology,
 * 		      New York University
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */


#ifndef __WFS_METADATA_XATTR_H__
#define __WFS_METADATA_XATTR_H__ 1

#include "wfs_metadata.h"

class wfs_metadata_xattr : public wfs_metadata {

 private:
  bool read_in_file();
  bool write_helper(const char *);

  static std::string xattr_name( std::string name );

  static int getxattr( int fd, std::string name, char *buf, int max_size );
  static int setxattr( int fd, std::string name, const char *buf, int size );

 public:

  wfs_metadata_xattr( wfs_file_id id = 0, int32_t vernum = 0 );
  wfs_metadata_xattr( const wfs_metadata_xattr & );
  ~wfs_metadata_xattr();

  void delete_file() { /* do nothing */ }

};

#endif // __WFS_METADATA_H__
